(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory() :
  typeof define === 'function' && define.amd ? define(factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, global.umd = factory());
})(this, (function () { 'use strict';

  function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);

    if (Object.getOwnPropertySymbols) {
      var symbols = Object.getOwnPropertySymbols(object);
      enumerableOnly && (symbols = symbols.filter(function (sym) {
        return Object.getOwnPropertyDescriptor(object, sym).enumerable;
      })), keys.push.apply(keys, symbols);
    }

    return keys;
  }

  function _objectSpread2(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = null != arguments[i] ? arguments[i] : {};
      i % 2 ? ownKeys(Object(source), !0).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }

    return target;
  }

  function _typeof(obj) {
    "@babel/helpers - typeof";

    return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) {
      return typeof obj;
    } : function (obj) {
      return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    }, _typeof(obj);
  }

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  }

  function addHTMLSuffix(url) {
    if (typeof url !== 'string') throw new Error('wx.redirectTo: invalid url:' + url);
    var urlArr = url.split('?');
    urlArr[0] += '.html';
    return typeof urlArr[1] !== 'undefined' ? urlArr[0] + '?' + urlArr[1] : urlArr[0];
  }

  function getRealRoute(pathname, url) {
    var isHtml = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
    if (!pathname) return url;
    isHtml && (url = isHtml ? addHTMLSuffix(url) : url);
    if (url.indexOf('/') === 0) return url.substr(1);
    if (url.indexOf('./') === 0) return getRealRoute(pathname, url.substr(2), !1);
    var index;
    var urlArrLength;
    var urlArr = url.split('/');

    for (index = 0, urlArrLength = urlArr.length; index < urlArrLength && urlArr[index] === '..'; index++) {
    }

    urlArr.splice(0, index);
    var pathArr = pathname.length > 0 ? pathname.split('/') : [];
    pathArr.splice(pathArr.length - index - 1, index + 1);
    var newPathArr = pathArr.concat(urlArr);
    return newPathArr.join('/');
  }
  var getDataType = function getDataType(data) {
    // get data type
    return Object.prototype.toString.call(data).split(' ')[1].split(']')[0];
  };
  var convertObjectValueToString = function convertObjectValueToString(obj) {
    // 把对象元素都转成字符串
    return Object.keys(obj).reduce(function (res, cur) {
      typeof obj[cur] === 'string' ? res[cur] = obj[cur] : typeof obj[cur] === 'number' ? res[cur] = obj[cur] + '' : res[cur] = Object.prototype.toString.apply(obj[cur]);
      return res;
    }, {});
  };
  function urlEncodeFormData(data, needEncode) {
    // 把对象生成queryString
    if (_typeof(data) !== 'object') return data;
    var tmpArr = [];

    for (var o in data) {
      if (Object.prototype.hasOwnProperty.call(data, o)) {
        if (needEncode) {
          try {
            tmpArr.push(encodeURIComponent(o) + '=' + encodeURIComponent(data[o]));
          } catch (t) {
            tmpArr.push(o + '=' + data[o]);
          }
        } else tmpArr.push(o + '=' + data[o]);
      }
    }

    return tmpArr.join('&');
  }
  var addQueryStringToUrl = function addQueryStringToUrl(originalUrl, newParams, needEncode) {
    // 生成url t:param obj
    if (typeof originalUrl === 'string' && _typeof(newParams) === 'object' && newParams) {
      var urlComponents = originalUrl.split('?');
      var host = urlComponents[0];
      var oldParams = (urlComponents[1] || '').split('&').reduce(function (res, cur) {
        if (typeof cur === 'string' && cur.length > 0) {
          var curArr = cur.split('=');
          var key = curArr[0];
          var value = curArr[1];
          res[key] = value;
        }

        return res;
      }, {});
      var refinedNewParams = Object.keys(newParams).reduce(function (res, cur) {
        _typeof(newParams[cur]) === 'object' ? res[encodeURIComponent(cur)] = encodeURIComponent(JSON.stringify(newParams[cur])) : res[encodeURIComponent(cur)] = encodeURIComponent(newParams[cur]);
        return res;
      }, {});
      var formData = urlEncodeFormData(Object.assign(oldParams, refinedNewParams), needEncode);

      if (formData) {
        return host + '?' + formData;
      }

      return host;
    }

    return originalUrl;
  };
  var base64ToArrayBuffer = function base64ToArrayBuffer(str) {
    var atobStr = atob(str);
    var leng = atobStr.length;
    var arr = new Uint8Array(leng);

    for (var r = 0; r < leng; r++) {
      arr[r] = atobStr.charCodeAt(r);
    }

    return arr.buffer;
  };
  var chars = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=';
  var atob = window.atob || function (input) {
    var str = String(input).replace(/[=]+$/, ''); // #31: ExtendScript bad parse of /=

    if (str.length % 4 === 1) {
      throw new InvalidCharacterError('\'atob\' failed: The string to be decoded is not correctly encoded.');
    }

    var bc = 0;
    var bs;
    var buffer;
    var idx = 0;
    var output = '';

    for (; buffer = str.charAt(idx++); // eslint-disable-line no-cond-assign
    // character found in table? initialize bit storage and add its ascii value;
    ~buffer && (bs = bc % 4 ? bs * 64 + buffer : buffer, // and if not first of each 4 characters,
    // convert the first 8 bits to one ascii character
    bc++ % 4) ? output += String.fromCharCode(255 & bs >> (-2 * bc & 6)) : 0) {
      // try to find character in table (0-63, not found => -1)
      buffer = chars.indexOf(buffer);
    }

    return output;
  };

  var userAgent = window.navigator.userAgent; // const isAndroid = userAgent.indexOf('Android') !== -1;

  var isIOS = (userAgent.indexOf('iPhone') !== -1 || userAgent.indexOf('iPad') !== -1) && !window.isIDE;
  var isWin = Boolean(window.isWinSDK);
  var isWeb = window.self !== window.top; // invoke callbacks

  var callbacks$1 = {};
  var callbackIndex = 0; // subscribe handlers

  var handlers = {};
  var eventPrefix = 'custom_event_';

  var invokeHandler = function invokeHandler(event, paramsString, callbackId) {
    if (isIOS) {
      window.webkit.messageHandlers.webInvokeHandler.postMessage({
        C: event,
        paramsString: paramsString,
        callbackId: callbackId
      });
    } else if (isWin) {
      var payload = {
        C: event,
        paramsString: paramsString,
        callbackId: callbackId,
        type: 'invoke'
      };
      window.FinClipExecuteCommandAsync({
        request: JSON.stringify(payload),
        persistent: false,
        onSuccess: function onSuccess() {},
        onFailure: function onFailure() {}
      });
    } else if (isWeb) {
      var _payload = {
        C: event,
        paramsString: paramsString,
        callbackId: callbackId,
        from: 'webview',
        type: 'invoke'
      };
      if (!window.parent) return;
      var jsCoreHandleResult = window.parent.postMessage(_payload, '*');

      if (typeof jsCoreHandleResult !== 'undefined' && typeof callbacks$1[callbackId] === 'function' && jsCoreHandleResult !== '') {
        try {
          jsCoreHandleResult = JSON.parse(jsCoreHandleResult);
        } catch (e) {
          jsCoreHandleResult = {};
        }

        callbacks$1[callbackId](jsCoreHandleResult);
        delete callbacks$1[callbackId];
      }
    } else {
      var _jsCoreHandleResult = FinChatJSCore.webInvokeHandler(event, paramsString, callbackId);

      if (_jsCoreHandleResult !== null && typeof _jsCoreHandleResult !== 'undefined' && typeof callbacks$1[callbackId] === 'function' && _jsCoreHandleResult !== '') {
        try {
          _jsCoreHandleResult = JSON.parse(_jsCoreHandleResult);
        } catch (e) {
          _jsCoreHandleResult = {};
        }

        callbacks$1[callbackId](_jsCoreHandleResult);
        delete callbacks$1[callbackId];
      }
    }
  };

  var invoke = function invoke(event, params, callback) {
    // postMessage
    var paramsString = JSON.stringify(params || {});
    var callbackId = ++callbackIndex;
    callbacks$1[callbackId] = callback;
    invokeHandler(event, paramsString, callbackId);
  };

  var webInvokeCallbackHandler = function webInvokeCallbackHandler(callbackId, params) {
    var callback = callbacks$1[callbackId];

    for (var i = 0; i < window.frames.length; i++) {
      window.frames[i].postMessage(JSON.stringify({
        callbackId: callbackId,
        params: params
      }), '*');
    }

    if (typeof callback === 'function') callback(params);
    delete callbacks$1[callbackId];
  };

  var webSubscribe = function webSubscribe(eventName, handler) {
    handlers[eventName] = handler;
  };

  var onHandlerList = {};

  var onWebSubscribe = function onWebSubscribe(eventName, handler) {
    if (typeof handler === 'function') {
      onHandlerList[eventName] = onHandlerList[eventName] || [];
      onHandlerList[eventName].push(handler);
    }

    if (!handlers[eventName]) {
      handlers[eventName] = function () {
        for (var _len = arguments.length, params = new Array(_len), _key = 0; _key < _len; _key++) {
          params[_key] = arguments[_key];
        }

        if (onHandlerList[eventName] && onHandlerList[eventName].length) {
          onHandlerList[eventName].forEach(function (func) {
            func.apply(void 0, params);
          });
        }
      };
    }
  };

  var offWebSubscribe = function offWebSubscribe(eventName, handler) {
    var idx = (onHandlerList[eventName] || []).findIndex(function (item) {
      return item === handler;
    });

    if (idx > -1) {
      onHandlerList[eventName].splice(idx, 1);
    }
  };

  var subscribe = function subscribe(eventName, handler) {
    handlers[eventPrefix + eventName] = handler;
  };

  var subscribeHandler = function subscribeHandler(eventName, data, webviewId, reportParams) {
    // 执行注册的回调
    var handler = handlers[eventName];

    if (typeof handler === 'function') {
      return handler(data, webviewId, reportParams);
    }
  };

  var publish = function publish(eventName, params, webviewIds) {
    // publishHandler
    webviewIds = webviewIds || [];
    var paramsString = '';
    var event = eventName;
    paramsString = JSON.stringify(params);
    webviewIds = JSON.stringify(webviewIds);
    publishHandler(event, paramsString, webviewIds);
  };

  var publishHandler = function publishHandler(event, paramsString, webviewIds) {
    // publishHandler
    if (isIOS) {
      window.webkit.messageHandlers.publishHandler.postMessage({
        event: event,
        paramsString: paramsString,
        webviewIds: webviewIds
      });
    } else if (isWin) {
      var payload = {
        event: event,
        paramsString: paramsString,
        webviewIds: webviewIds,
        type: 'publish'
      };
      window.FinClipExecuteCommandAsync({
        request: JSON.stringify(payload),
        persistent: false,
        onSuccess: function onSuccess(res) {// _this.callbacks[callbackId](res)
          // delete _this.callbacks[callbackId]
        },
        onFailure: function onFailure(code, msg) {}
      }); // window.chrome.webview.postMessage({
      //   event: event,
      //   paramsString: paramsString,
      //   webviewIds: webviewIds,
      //   type: 'publish',
      // });
    } else if (isWeb) {
      var _payload2 = {
        event: event,
        paramsString: paramsString,
        from: 'webview',
        type: 'publish'
      };

      if (window.parent) {
        window.parent.postMessage(_payload2, '*');
      }
    } else {
      FinChatJSCore.publishHandler(event, paramsString, webviewIds);
    }
  };

  var invokeMethod = function invokeMethod(apiName, opts, innerCb) {
    var options = opts || {};
    var innerFns = innerCb || {};
    var params = {};

    for (var i in options) {
      if (typeof options[i] === 'function') {
        params[i] = options[i];
        delete options[i];
      }
    }

    var sysEventFns = {};

    for (var s in innerFns) {
      if (typeof innerFns[s] === 'function') {
        sysEventFns[s] = innerFns[s];
      }
    }

    invoke(apiName, options, function (res) {
      res.errMsg = res.errMsg || apiName + ':ok';
      var isOk = res.errMsg.indexOf(apiName + ':ok') === 0;
      var isCancel = res.errMsg.indexOf(apiName + ':cancel') === 0;
      var isFail = res.errMsg.indexOf(apiName + ':fail') === 0;

      if (isOk) {
        typeof sysEventFns.beforeAll === 'function' && sysEventFns.beforeAll(res);
        typeof sysEventFns.beforeSuccess === 'function' && sysEventFns.beforeSuccess(res);
        typeof params.success === 'function' && params.success(res);
        typeof sysEventFns.afterSuccess === 'function' && sysEventFns.afterSuccess(res);
      } else if (isCancel) {
        res.errMsg = res.errMsg.replace(apiName + ':cancel', apiName + ':fail cancel');
        typeof params.fail === 'function' && params.fail(res);
        typeof sysEventFns.beforeCancel === 'function' && sysEventFns.beforeCancel(res);
        typeof params.cancel === 'function' && params.cancel(res);
        typeof sysEventFns.afterCancel === 'function' && sysEventFns.afterCancel(res);
      } else if (isFail) {
        typeof sysEventFns.beforeFail === 'function' && sysEventFns.beforeFail(res);
        typeof params.fail === 'function' && params.fail(res);
        typeof sysEventFns.afterFail === 'function' && sysEventFns.afterFail(res);
      }

      typeof params.complete === 'function' && params.complete(res);
      typeof sysEventFns.afterAll === 'function' && sysEventFns.afterAll(res);
    });
  };

  if (isWeb) {
    window.addEventListener('message', function (_ref) {
      var _ref$data = _ref.data,
          data = _ref$data === void 0 ? {} : _ref$data;
      var type = data.type;

      if (type === 'webInvokeCallbackHandler') {
        var callbackId = data.callbackId,
            params = data.params;
        webInvokeCallbackHandler(callbackId, params);
      } else if (type === 'subscribeHandler') {
        var eventName = data.eventName,
            _params = data.params;
        subscribeHandler(eventName, _params);
      }
    });
  }

  function initBridge() {
    window.FinChatJSBridge = {
      invoke: invoke,
      invokeCallbackHandler: webInvokeCallbackHandler,
      webInvokeCallbackHandler: webInvokeCallbackHandler,
      subscribe: subscribe,
      subscribeHandler: subscribeHandler,
      // Mark: 兼容的调用方式
      webSubscribeCallBackHandler: subscribeHandler,
      publish: publish,
      publishHandler: publishHandler,
      webSubscribe: webSubscribe
    };
  }

  var mop_bridge = {
    initBridge: initBridge,
    invoke: invoke,
    invokeCallbackHandler: webInvokeCallbackHandler,
    webInvokeCallbackHandler: webInvokeCallbackHandler,
    subscribe: subscribe,
    subscribeHandler: subscribeHandler,
    // Mark: 兼容的调用方式
    webSubscribeCallBackHandler: subscribeHandler,
    publish: publish,
    publishHandler: publishHandler,
    invokeMethod: invokeMethod,
    webSubscribe: webSubscribe,
    onWebSubscribe: onWebSubscribe,
    offWebSubscribe: offWebSubscribe
  };

  window.jssdkVersion = '1.4.20-wx.4';

  var currentRoute = '';
  var stackLength = null;
  var tabBar = null;
  var canNavigateTo = true;
  var isInitd = false;
  var eventHandlers = [];
  var callbacks = [];
  var errCallbacks = []; // 调试时设为 true，避免在未实现 jssdkConfig 的 sdk 下执行不了 api
  // 后续可以设置为初始 false

  var isReady = true;
  /**
   * 提供MOP小程序WebView的JSSDK交互功能
   * 代码示例:
   * <code>
   window.fc.miniProgram.navigateBack({
     success: function(res) {
       console.log('navigateBack callback:');
       console.log(res);
       alert(JSON.stringify(res))
     }
   });
   * </code>
   */

  function checkUrl(apiName, args, params) {
    // Mark: 未实现传递 tabbar 的情况不校验
    function fail(res) {
      if (typeof params.fail === 'function') {
        params.fail(res);
      }

      if (typeof params.complete === 'function') {
        params.complete(res);
      }
    }

    if (tabBar === null) {
      return true;
    }

    if (args.url.startsWith('/')) {
      args.url = args.url.slice(1);
    }

    if ((apiName === 'redirectTo' || apiName === 'navigateTo') && tabBar && tabBar.list.find(function (e) {
      return args.url.indexOf(e.pagePath) === 0;
    })) {
      fail({
        errMsg: apiName + "fail :can not ".concat(apiName, " to a tabbar page")
      });
      return false;
    } else if (apiName === 'switchTab') {
      if (!tabBar || !tabBar.list.find(function (e) {
        return args.url.indexOf(e.pagePath) === 0;
      })) {
        fail({
          errMsg: apiName + ':fail can not switch to no-tabBar page'
        });
        return false;
      }
    }

    return true;
  }

  var APIS = {
    config: function config() {
      var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      isReady = false;
      mop_bridge.invoke('jssdkConfig', params, function (res) {
        var isOK = false;

        if (res && res.errMsg) {
          // SDK 未实现时默认通过
          if (/:fail/.test(res.errMsg)) {
            // android 代理会在 fail 上多包一层 ok, 这里主要判断 fail
            isOK = false;
          } else {
            isOK = /:ok/.test(res.errMsg) || /未实现/.test(res.errMsg);
          }

          res.errMsg = res.errMsg.replace('jssdkConfig', 'config');
        }

        if (isOK) {
          isReady = true;
          callbacks.forEach(function (fn) {
            fn();
            callbacks = [];
          });
        } else {
          errCallbacks.forEach(function (fn) {
            fn(res);
            errCallbacks = [];
          });
        }
      });
    },
    ready: function ready(fn) {
      if (typeof fn === 'function') {
        if (isReady) {
          fn();
        } else {
          callbacks.push(fn);
        }
      }
    },
    error: function error(fn) {
      if (typeof fn === 'function') {
        if (!isReady) {
          errCallbacks.push(fn);
        }
      }
    },
    init: function init() {
      if (isInitd) return;
      console.log('JSSDK Client. Version:', window.jssdkVersion);
      isInitd = true;

      try {
        mop_bridge.subscribe('webviewEvent', function (data) {
          eventHandlers.forEach(function (handler) {
            handler(data.data);
          });
        });
        mop_bridge.subscribe('webviewCurrentRoute', function (data) {
          currentRoute = data.route;
          tabBar = data.tabBar;
          stackLength = data.stackLength;
          canNavigateTo = data.canNavigateTo !== undefined ? data.canNavigateTo : true;
        });
        mop_bridge.publish('onWebviewEvent', {
          key: 'getCurrentRoute'
        }); // 兼容逻辑，命名空间修改后，部分 API 不在 miniProgram 中，这里做个旧版本兼容

        Object.keys(APIS.miniProgram).forEach(function (key) {
          var fn = APIS.miniProgram[key];

          APIS.miniProgram[key] = function () {
            for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
              args[_key] = arguments[_key];
            }

            if (!isReady) {
              var params = args[0];

              if (params && params.fail && typeof params.fail === 'function') {
                params.fail({
                  errMsg: "".concat(key, ":fail please invoke api after ready")
                });
              }

              return;
            }

            if (_typeof(args[0]) === 'object') {
              args[0] = _objectSpread2({}, args[0]);
            }

            fn.apply(null, args);
          };
        });
        Object.keys(APIS).forEach(function (key) {
          if (/config|ready|error|miniProgram/.test(key)) {
            return;
          }

          var fn = APIS[key];

          APIS[key] = APIS.miniProgram[key] = function () {
            for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
              args[_key2] = arguments[_key2];
            }

            if (!isReady) {
              var params = args[0];

              if (params && params.fail && typeof params.fail === 'function') {
                params.fail({
                  errMsg: "".concat(key, ":fail please invoke api after ready")
                });
              }

              return;
            }

            if (_typeof(args[0]) === 'object') {
              args[0] = _objectSpread2({}, args[0]);
            }

            fn.apply(null, args);
          };
        });
      } catch (e) {}
    },
    // 命名空间调整，与小程序有关的 API 均在 miniProgram 下
    miniProgram: {
      /**
       * 关闭当前页面，返回上一页面或多级页面。
       * @param {Object} params {
       *  delta: 1,
       *  success: function(res) {},
       *  fail: function(res) {},
       *  complete: function(res) {},
       * }
       */
      navigateBack: function navigateBack() {
        var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        var data = params || {};
        data.name = 'navigateBack';
        data.arg = {
          delta: params.delta || 1
        };
        mop_bridge.invokeMethod('invokeMiniProgramAPI', data);
      },

      /**
      * 保留当前页面，跳转到应用内的某个页面。但是不能跳到 tabbar 页面。
      * @param {Object} params {
      *  url: '',
      *  success: function(res) {},
      *  fail: function(res) {},
      *  complete: function(res) {},
      * }
      */
      navigateTo: function navigateTo(params) {
        var data = _objectSpread2({}, params || {});

        var err = null;

        if (!canNavigateTo) {
          err = {
            errMsg: 'navigateTo:fail webview count limit exceed'
          };
          return;
        }

        if (!params.url) {
          err = {
            errMsg: 'navigateTo:fail Invalid parameter url'
          };
        }

        if (err) {
          if (params.fail && typeof params.fail === 'function') {
            params.fail(err);
          }

          if (params.complete && typeof params.complete === 'function') {
            params.complete(err);
          }

          return;
        }

        params.url = getRealRoute(currentRoute, params.url); // params.url = utils.encodeUrlQuery(params.url)

        data.name = 'navigateTo';
        data.arg = {
          url: params.url || ''
        };

        if (checkUrl(data.name, data.arg, params)) {
          mop_bridge.invokeMethod('invokeMiniProgramAPI', data);
        }
      },

      /**
      * 关闭当前页面，跳转到应用内的某个页面。但是不允许跳转到 tabbar 页面。
      * @param {Object} params {
      *  url: '',
      *  success: function(res) {},
      *  fail: function(res) {},
      *  complete: function(res) {},
      * }
      */
      redirectTo: function redirectTo(params) {
        var data = _objectSpread2({}, params || {});

        var err = null;

        if (!params.url) {
          err = {
            errMsg: 'redirectTo:fail Invalid parameter url'
          };
        }

        if (err) {
          if (params.fail && typeof params.fail === 'function') {
            params.fail(err);
          }

          if (params.complete && typeof params.complete === 'function') {
            params.complete(err);
          }

          return;
        }

        params.url = getRealRoute(currentRoute, params.url); // params.url = utils.encodeUrlQuery(params.url)

        data.name = 'redirectTo';
        data.arg = {
          url: params.url || ''
        };

        if (checkUrl(data.name, data.arg, params)) {
          mop_bridge.invokeMethod('invokeMiniProgramAPI', data);
        }
      },

      /**
      * 跳转到 tabBar 页面，并关闭其他所有非 tabBar 页面。
      * @param {Object} params {
      *  url: '',
      *  success: function(res) {},
      *  fail: function(res) {},
      *  complete: function(res) {},
      * }
      */
      switchTab: function switchTab(params) {
        var data = _objectSpread2({}, params || {});

        var err = null;

        if (!params.url) {
          err = {
            errMsg: 'switchTab:fail Invalid parameter url'
          };
        }

        if (err) {
          if (params.fail && typeof params.fail === 'function') {
            params.fail(err);
          }

          if (params.complete && typeof params.complete === 'function') {
            params.complete(err);
          }

          return;
        }

        params.url = getRealRoute(currentRoute, params.url);

        if (/\?.*$/.test(params.url)) {
          console.warn('wx.switchTab: url 不支持 queryString');
          params.url = params.url.replace(/\?.*$/, '');
        } // params.url = utils.encodeUrlQuery(params.url)


        data.name = 'switchTab';
        data.arg = {
          url: params.url || ''
        };

        if (checkUrl(data.name, data.arg, params)) {
          mop_bridge.invokeMethod('invokeMiniProgramAPI', data);
        }
      },

      /**
      * 关闭所有页面，打开到应用内的某个页面
      * @param {Object} params {
      *  url: '',
      *  success: function(res) {},
      *  fail: function(res) {},
      *  complete: function(res) {},
      * }
      */
      reLaunch: function reLaunch(params) {
        var data = _objectSpread2({}, params || {});

        var err = null;

        if (!params.url) {
          err = {
            errMsg: 'reLaunch:fail Invalid parameter url'
          };
        }

        if (err) {
          if (params.fail && typeof params.fail === 'function') {
            params.fail(err);
          }

          if (params.complete && typeof params.complete === 'function') {
            params.complete(err);
          }

          return;
        }

        params.url = getRealRoute(currentRoute, params.url); // params.url = utils.encodeUrlQuery(params.url)

        data.name = 'reLaunch';
        data.arg = {
          url: params.url || ''
        };
        mop_bridge.invokeMethod('invokeMiniProgramAPI', data);
      },

      /**
      * 发送消息
      * @param {Object} params {
      *  data: '',
      *  success: function(res) {},
      *  fail: function(res) {},
      *  complete: function(res) {},
      * }
      */
      postMessage: function postMessage(params) {
        var data = params || {};
        data.name = 'postMessage';
        data.arg = params.data || {};
        mop_bridge.invokeMethod('invokeMiniProgramAPI', data);
      },

      /**
      * 取当前运行环境
      * @param {Object} params {
      *  success: function(res) {}
      * }
      */
      getEnv: function getEnv(params) {
        if (params && _typeof(params) === 'object' && typeof params.success === 'function') {
          params.success({
            version: window.jssdkVersion,
            env: window.__fcjs_environment || {}
          });
        } else if (typeof params === 'function') {
          params({
            version: window.jssdkVersion,
            env: window.__fcjs_environment || {}
          });
        } else {
          console.warn('getEnv params invalid');
        }
      },

      /**
      * 关闭小程序
      */
      close: function close(params) {
        var data = params || {};
        data.name = 'close';
        data.arg = {};
        mop_bridge.invokeMethod('invokeMiniProgramAPI', data);
      },

      /**
      * 小程序跳转
      * @param {*} params {
      * appId: string, // 要打开的小程序 appId
      * path: string, //打开的页面路径
      * extraData: Object, // 需要传递给目标小程序的数据,App.onLaunch，App.onShow 中获取到这份数据
      *  success: function(res) {},
      *  fail: function(res) {},
      *  complete: function(res) {},
      * }
      */
      navigateToMiniProgram: function navigateToMiniProgram(params) {
        var data = params || {};
        data.name = 'navigateToMiniProgram';
        data.arg = {
          appId: params.appId,
          path: params.path,
          extraData: params.extraData
        };
        mop_bridge.invokeMethod('invokeMiniProgramAPI', data);
      },

      /**
      * 返回上一个小程序
      * @param {*} params {
      * extraData: Object, // 需要传递给目标小程序的数据,App.onLaunch，App.onShow 中获取到这份数据
      *  success: function(res) {},
      *  fail: function(res) {},
      *  complete: function(res) {},
      * }
      */
      navigateBackMiniProgram: function navigateBackMiniProgram(params) {
        var data = params || {};
        data.name = 'navigateBackMiniProgram';
        data.arg = {
          extraData: params.extraData
        };
        mop_bridge.invokeMethod('invokeMiniProgramAPI', data);
      },

      /**
      * 注册小程序onShow时回调
      * @param {*} params {
      *
      * }
      */
      onShow: function onShow(params) {
        var data = params || {};
        mop_bridge.subscribe('pageonshow', data);
      },
      onHide: function onHide(params) {
        var data = params || {};
        mop_bridge.subscribe('pageonhide', data);
      },
      onUnload: function onUnload(params) {
        var data = params || {};
        mop_bridge.webSubscribe('pageonunload', data);
      },

      /**
      * 监听小程序发送的事件
      * @param {*} handler
      */
      onWebviewEvent: function onWebviewEvent(handler) {
        if (typeof handler === 'function') {
          eventHandlers.push(handler);
        }
      },

      /**
      * 移除监听小程序发送的事件
      * @param {*} handler
      */
      offWebviewEvent: function offWebviewEvent(handler) {
        if (typeof handler === 'function') {
          eventHandlers = eventHandlers.filter(function (f) {
            return f !== handler;
          });
        }
      },

      /**
      * 触发 webview 标签绑定的 bindevent 方法
      * @param {*} data
      */
      sendWebviewEvent: function sendWebviewEvent(data) {
        mop_bridge.publish('onWebviewEvent', {
          key: 'sendEvent',
          params: data
        });
      },
      postInstantMessage: function postInstantMessage(params) {
        if (params && params.data) {
          mop_bridge.publish('onWebviewEvent', {
            key: 'sendInstantEvent',
            params: params.data
          });
        }
      },
      getRoutes: function getRoutes(params) {
        params.success({
          currentRoute: currentRoute,
          tabBar: tabBar,
          stack: stackLength
        });
      }
    },

    /**
     * 下载文件
     * @param {Object} params {
     *  url: '',
     *  header: '',
     *  timeout: 3000,
     *  filePath: ''
     *  success: function(res) {},
     *  fail: function(res) {},
     *  complete: function(res) {},
     * }
     */
    downloadFile: function downloadFile(params) {
      var data = params || {};
      data.name = 'downloadFile';
      data.arg = {
        url: params.url,
        header: params.header,
        timeout: params.timeout,
        filePath: params.filePath
      };
      mop_bridge.invokeMethod('invokeMiniProgramAPI', data);
    },

    /**
     * 打开文件，预览文件
     * @param {*} params {
     *  fileType: 'pdf',
     *  filePath: ''
     *  success: function(res) {},
     *  fail: function(res) {},
     *  complete: function(res) {},
     * }
     */
    openDocument: function openDocument(params) {
      var data = params || {};
      data.name = 'openDocument';
      data.arg = {
        filePath: params.filePath,
        fileType: params.fileType
      };
      mop_bridge.invokeMethod('invokeMiniProgramAPI', data);
    },

    /**
     * 选择图片
     * @param {*} params {
     * count: 1, // 默认9
     * sizeType: ['original', 'compressed'], // 可以指定是原图还是压缩图，默认二者都有
     * sourceType: ['album', 'camera'], // 可以指定来源是相册还是相机，默认二者都有
     *  success: function(res) {},
     *  fail: function(res) {},
     *  complete: function(res) {},
     * }
     */
    chooseImage: function chooseImage(params) {
      var data = params || {};
      data.name = 'chooseImage';
      data.arg = {
        count: params.count || 9,
        sizeType: params.sizeType || ['original', 'compressed'],
        sourceType: params.sourceType || ['album', 'camera']
      };
      mop_bridge.invokeMethod('invokeMiniProgramAPI', data);
    },

    /**
     * 获取本地图片 base64
     * @param {*} params
     * path: 本地图片路径
     */
    getLocalImgData: function getLocalImgData(params) {
      var data = params || {};
      data.name = 'getLocalImgData';
      data.arg = {
        path: params.path
      };
      mop_bridge.invokeMethod('invokeMiniProgramAPI', data);
    },

    /**
     * 获取小程序信息
     * @param {callback} cb function(res) {}
     */
    getAppletInfo: function getAppletInfo(params) {
      var data = params || {};
      data.name = 'getAppletInfo';
      data.arg = {};
      mop_bridge.invokeMethod('invokeMiniProgramAPI', data);
    },

    /**
     * 判断 H5 是否能返回上一页
     * @param {Object} params
     */
    canGoBack: function canGoBack(params) {
      var data = params || {};
      data.name = 'canGoBack';
      data.arg = {};
      mop_bridge.invokeMethod('invokeMiniProgramAPI', data);
    },

    /**
    * 判断小程序页面是否能返回上一页
    * @param {Object} params
    */
    canNavigateBack: function canNavigateBack(params) {
      var data = params || {};
      data.name = 'canNavigateBack';
      data.arg = {};
      mop_bridge.invokeMethod('invokeMiniProgramAPI', data);
    },

    /**
    * webview 页面设置 navigation title
    * @param {Object} params
    *   title: String
    * }
    */
    setNavigationBarTitle: function setNavigationBarTitle(params) {
      var data = params || {};
      data.name = 'setNavigationBarTitle';
      data.arg = {
        title: String(params.title || '')
      };
      mop_bridge.invokeMethod('invokeMiniProgramAPI', data);
    },

    /**
     * @description 获取本地缓存
     * @param {Object} params
     * @param {String} params.key
     *  success: function(res) {},
     *  fail: function(res) {},
     *  complete: function(res) {},
     */
    getStorage: function getStorage(params) {
      if (typeof params.key !== 'string') {
        throw new Error('Invalid parameter key');
      }

      var data = params || {};
      data.name = 'getStorage';
      data.arg = {
        key: params.key
      };
      mop_bridge.invokeMethod('invokeMiniProgramAPI', data, {
        beforeSuccess: function beforeSuccess(res) {
          if (typeof res.data === 'string') {
            try {
              var result = JSON.parse(res.data);

              if (result._type) {
                res.data = result.data;
              } else {
                res.data = result;
              }

              if (result._type === 'Date') {
                res.data = new Date(res.data);
              }
            } catch (error) {}
          }

          return res;
        }
      });
    },

    /**
     * @description 获取本地缓存的数据
     * @param {Object} params
     * @param {String} params.key
     * @param {String} params.data
     *  success: function(res) {},
     *  fail: function(res) {},
     *  complete: function(res) {},
     */
    setStorage: function setStorage(params) {
      if (typeof params.key !== 'string') {
        console.error('parameters error');
        return;
      }

      var _type = _typeof(params.data);

      if (params.data instanceof Date) {
        _type = 'Date';
      }

      try {
        params.data = JSON.stringify({
          data: params.data,
          _type: _type
        });
      } catch (error) {
        console.error('parameters data error');
        return;
      }

      var data = params || {};
      data.name = 'setStorage';
      data.arg = {
        key: params.key,
        data: params.data
      };
      mop_bridge.invokeMethod('invokeMiniProgramAPI', data);
    },

    /**
     * @description 移除本地缓存
     * @param {Object} params
     * @param {String} params.key
     * success: function(res) {},
     * fail: function(res) {},
     * complete: function(res) {},
     */
    removeStorage: function removeStorage(params) {
      if (typeof params.key !== 'string') {
        console.error('parameters error');
        return;
      }

      var data = params || {};
      data.name = 'removeStorage';
      data.arg = {
        key: params.key
      };
      mop_bridge.invokeMethod('invokeMiniProgramAPI', data);
    },

    /**
     * @description 清除所有的缓存
     * success: function(res) {},
     * fail: function(res) {},
     * complete: function(res) {},
     */
    clearStorage: function clearStorage(params) {
      var data = params || {};
      data.name = 'clearStorage';
      data.arg = {};
      mop_bridge.invokeMethod('invokeMiniProgramAPI', data);
    },

    /**
     * @description 获取储存的信息
     * success: function(res) {},
     * fail: function(res) {},
     * complete: function(res) {},
     */
    getStorageInfo: function getStorageInfo(params) {
      var data = params || {};
      data.name = 'getStorageInfo';
      data.arg = {};
      mop_bridge.invokeMethod('invokeMiniProgramAPI', data);
    },

    /**
     * 调用app原生接口
     * @param {*} params {
     *  name: String, // 原生APP方法，命名规范，加【 user_define_ 】前缀
     *  data: Object, // 需要传递给原生APP的数据
     *  success: function(res) {},
     *  fail: function(res) {},
     *  complete: function(res) {},
     * }
     */
    callHandler: function callHandler(params) {
      var data = params || {};
      mop_bridge.invokeMethod(params.name, data);
    },

    /**
     * @description 获取当前地理位置信息
     * @param {Object} params
     * @param {String}  params.type 目前不管该参数如何，都会返回gcj02坐标
     * @param {Boolean}  params.altitude 传入 true 会返回高度信息，由于获取高度需要较高精确度，会减慢接口返回速度
     */
    getLocation: function getLocation(params) {
      var data = params || {};
      data.name = 'getLocation';
      data.arg = {
        type: params.type,
        altitude: params.altitude
      };
      mop_bridge.invokeMethod('invokeMiniProgramAPI', data);
    },

    /**
     * @description 打开地图位置
     * @param {Object} params
     * @param {Number} params.latitude 目标地纬度
     * @param {Number} params.longitude 目标地经度
     */
    chooseLocation: function chooseLocation(params) {
      var data = params || {};
      data.name = 'chooseLocation';
      data.arg = {
        latitude: params.latitude,
        longitude: params.longitude
      };
      mop_bridge.invokeMethod('invokeMiniProgramAPI', data);
    },

    /**
    * @description 请求 api
    * @param {Object}} params
    */
    request: function request() {
      var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      if (!params.url || typeof params.url !== 'string') {
        throw new Error('Invalid parameter url');
      }

      var headerType = getDataType(params.header);
      params.header = params.header || {};
      params.header = convertObjectValueToString(params.header);

      if (headerType !== 'Undefined' && headerType !== 'Object') {
        console.warn('request: header must be an object');
        params.header = {};
      }

      params.header = Object.keys(params.header).reduce(function (res, cur) {
        cur.toLowerCase() === 'content-type' ? res[cur.toLowerCase()] = params.header[cur] : res[cur] = params.header[cur];
        return res;
      }, {});
      params.method && (params.method = params.method.toUpperCase());
      var headers = params.header || {};
      var requestMethod = typeof params.method === 'string' ? params.method.toUpperCase() : 'GET';
      var data = '';
      params.dataType = params.dataType || 'json';
      headers['content-type'] = headers['content-type'] || 'application/json';
      data = !params.data ? '' : typeof params.data !== 'string' ? headers['content-type'].indexOf('application/x-www-form-urlencoded') > -1 ? urlEncodeFormData(params.data, !0) : headers['content-type'].indexOf('application/json') > -1 ? JSON.stringify(params.data) : _typeof(params.data) === 'object' ? JSON.stringify(params.data) : data.toString() : params.data;

      if (requestMethod === 'GET') {
        params.url = addQueryStringToUrl(params.url, params.data);
      }

      mop_bridge.invokeMethod('invokeMiniProgramAPI', {
        name: 'request',
        arg: {
          url: params.url,
          data: data,
          header: headers,
          method: requestMethod,
          dataType: params.dataType || 'json',
          responseType: params.responseType,
          taskId: String(Math.random())
        },
        success: params.success,
        fail: params.fail,
        complete: params.complete
      }, {
        beforeSuccess: function beforeSuccess(res) {
          if (res.isBase64) {
            if (params.responseType && params.responseType.toLowerCase() === 'arraybuffer') {
              res.data = base64ToArrayBuffer(res.data);
            } else {
              res.data = atob(res.data);
            }
          }

          if (params.dataType === 'json') {
            try {
              res.data = JSON.parse(res.data);
            } catch (e) {}
          }

          res.statusCode = parseInt(res.statusCode);
        }
      });
    },
    getSuperviseInfo: function getSuperviseInfo(params) {
      var data = params || {};
      data.name = 'getSuperviseInfo';
      data.arg = {};
      mop_bridge.invokeMethod('invokeMiniProgramAPI', data);
    },

    /**
     * H5 调用原生方法
     * @param {String} name
     * @param {Object} params
     * @param {Funciton} callback
     */
    callNativeAPI: function callNativeAPI(name, params, callback) {
      mop_bridge.invoke(name, params, callback);
    },

    /**
     * 注册 H5 方法供原生调用
     * @param {String} name
     * @param {Function} handler
     */
    registNativeAPIHandler: function registNativeAPIHandler(name, handler) {
      mop_bridge.webSubscribe(name, handler);
    },
    onNativeAPIHandler: function onNativeAPIHandler(name, handler) {
      mop_bridge.onWebSubscribe(name, handler);
    },
    offNativeAPIHandler: function offNativeAPIHandler(name, handler) {
      mop_bridge.offWebSubscribe(name, handler);
    },
    // 发送事件到基础库移除 timeout 定时器
    complete: function complete() {
      mop_bridge.publish('onWebviewEvent', {
        key: 'complete'
      });
    },
    // 向 sdk 请求权限
    authorize: function authorize(params) {
      var data = params || {};
      data.name = 'authorize';
      data.arg = {
        scope: params.scope
      };
      mop_bridge.invokeMethod('invokeMiniProgramAPI', data);
    }
  };
  delete APIS.requset;
  var finalFt = null;

  if (window.ft) {
    console.warn('JSSDK is already init.');
    finalFt = window.ft;
  } else {
    mop_bridge.initBridge();
    APIS.init();
    finalFt = window.ft = window.fc = window.wx = APIS;
    window.addEventListener('message', function (e) {
      try {
        var _JSON$parse = JSON.parse(e.data),
            callbackId = _JSON$parse.callbackId,
            params = _JSON$parse.params;

        window.FinChatJSBridge.webInvokeCallbackHandler(callbackId, params);
      } catch (e) {}
    }, false);
    Object.defineProperty(window, 'wx', {
      get: function get() {
        return APIS;
      },
      set: function set(newValue) {
        console.warn('已禁止修改 wx 对象', newValue);
        return APIS;
      },
      configurable: true,
      enumerable: true
    });
  }

  var JSSDK = finalFt;

  return JSSDK;

}));
//# sourceMappingURL=js-sdk.js.map
